#--------------------------------------------------------------------------------------------------------------------------
# Read Values from Solis via Modbus
#
# This module generates an insert request as configureated and send it to mysql database
#
# License:
# Feel free to use this code in your private or business environment or as example for your own code.
# Redistribution is only allowed with no changes.
# For any other kind of usage, please ask me.
# Ralf Amandi, Avarix GmbH
#
# 14.05.2021 Version 1.1
#--------------------------------------------------------------------------------------------------------------------------
import mysql.connector
import logger
import time

#--------------------------------------------------------------------------------------------------------------------------
# Generate SQL
#--------------------------------------------------------------------------------------------------------------------------
useSQL = False
insertInterval = 120
lastTime = 0
sqlNames = ()
sqlValues = ()
sqlVals = ()
sqlConfig = {"Host":"localhost", "Databse":"Solarstatistik", "Group":"2"} # see cfg File Host, User, Passwod, Database
sqlMapping = {}

def SetConfig(config):
	global sqlConfig, useSQL, sqlMapping
	sqlConfig=config["MYSQL"]
	sqlMapping=config["MYSQL-Mapping"]
	useSQL = sqlConfig["Enable"] == "yes"
	insertInterval = sqlConfig["InsertInterval"]
	
def AddValue( name, val):
	global sqlVals, sqlNames, sqlVals
	sqlNames.append(name)
	sqlValues.append("%s")
	sqlVals.append(val)

# Prepare the statement, fill sqlNames, sqlValues and sqlVals
# Returns a text
def PrepareSQL(v):
	global sqlVals, sqlNames, sqlValues, mysqlConfig
	try:
		sqlNames = list()
		sqlValues = list()
		sqlVals = list()
		for name in sqlMapping.keys():			
			AddValue(name,eval(sqlMapping[name],{"v":v,"round":round,"config":sqlConfig}))
		sql= "REPLACE INTO "+sqlConfig["Table"]+" ("+ ",".join(sqlNames) + ") VALUES ("+ ",".join(sqlValues) +"); with "+str(sqlVals)
	except BaseException as e:
		print(e, "Error generating SQL, done so far ",sqlNames);
		sql = "";
	return sql

def Execute():
	mydb = mysql.connector.connect( host=sqlConfig["Host"], user=sqlConfig["User"], password=sqlConfig["Password"], database=sqlConfig["Database"])
	mycursor = mydb.cursor()
	mycursor.execute("REPLACE INTO "+sqlConfig["Table"]+" ("+ ",".join(sqlNames) + ") VALUES ("+ ",".join(sqlValues) +");", sqlVals)
	mydb.commit()
	r = mycursor.rowcount
	mycursor = None
	mydb = None
	return r
	
def Insert(vals):
	#global lastTime
	#if (useSQL and time.time()>=lastTime+insertInterval):
	#lastTime=time.time()
	sql = PrepareSQL(vals)
	logger.logMessage(3,sql)
	Execute()
